"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fromNumber = function (v) {
    return v << 16 >> 16;
};
class Int16 {
    static add(a, b) {
        return fromNumber(fromNumber(a) + fromNumber(b));
    }
    static sub(a, b) {
        return fromNumber(fromNumber(a) - fromNumber(b));
    }
    static mul(a, b) {
        return fromNumber(fromNumber(a) * fromNumber(b));
    }
    static div(a, b) {
        return fromNumber(fromNumber(a) / fromNumber(b));
    }
    static mod(a, b) {
        return fromNumber(a) % fromNumber(b);
    }
    static fromNumber(v) {
        return v << 16 >> 16;
    }
    static clamp(value, min, max) {
        value = fromNumber(value);
        min = fromNumber(min);
        max = fromNumber(max);
        return value < min ? min : (value > max ? max : value);
    }
}
Int16.min = -32768;
Int16.max = 32767;
Int16.bitWidth = 16;
Int16.isSigned = true;
exports.Int16 = Int16;
//# sourceMappingURL=Int16.js.map