"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const imul = Math.imul;
class Int32 {
    static add(a, b) {
        return ((a | 0) + (b | 0)) | 0;
    }
    static sub(a, b) {
        return ((a | 0) - (b | 0)) | 0;
    }
    static mul(a, b) {
        return imul((a | 0), (b | 0)) | 0;
    }
    static div(a, b) {
        return ((a | 0) / (b | 0)) | 0;
    }
    static mod(a, b) {
        return ((a | 0) % (b | 0));
    }
    static fromNumber(v) {
        return v | 0;
    }
    static clamp(value, min, max) {
        value |= 0;
        min |= 0;
        max |= 0;
        return value < min ? min : (value > max ? max : value);
    }
}
Int32.min = -2147483648;
Int32.max = 2147483647;
Int32.bitWidth = 32;
Int32.isSigned = true;
exports.Int32 = Int32;
//# sourceMappingURL=Int32.js.map