"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fromNumber = function (v) {
    return v << 24 >> 24;
};
class Int8 {
    static add(a, b) {
        return fromNumber(fromNumber(a) + fromNumber(b));
    }
    static sub(a, b) {
        return fromNumber(fromNumber(a) - fromNumber(b));
    }
    static mul(a, b) {
        return fromNumber(fromNumber(a) * fromNumber(b));
    }
    static div(a, b) {
        return fromNumber(fromNumber(a) / fromNumber(b));
    }
    static mod(a, b) {
        return fromNumber(a) % fromNumber(b);
    }
    static fromNumber(v) {
        return v << 24 >> 24;
    }
    static clamp(value, min, max) {
        value = fromNumber(value);
        min = fromNumber(min);
        max = fromNumber(max);
        return value < min ? min : (value > max ? max : value);
    }
}
Int8.min = -128;
Int8.max = 127;
Int8.bitWidth = 8;
Int8.isSigned = true;
exports.Int8 = Int8;
//# sourceMappingURL=Int8.js.map