"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class UInt16 {
    static add(a, b) {
        return ((a & 0xffff) + (b & 0xffff)) & 0xffff;
    }
    static sub(a, b) {
        return ((a & 0xffff) - (b & 0xffff)) & 0xffff;
    }
    static mul(a, b) {
        return ((a & 0xffff) * (b & 0xffff)) & 0xffff;
    }
    static div(a, b) {
        return ((a & 0xffff) / (b & 0xffff)) & 0xffff;
    }
    static mod(a, b) {
        return ((a & 0xffff) % (b & 0xffff)) & 0xffff;
    }
    static fromNumber(v) {
        return v & 0xffff;
    }
    static clamp(value, min, max) {
        value &= 0xffff;
        min &= 0xffff;
        max &= 0xffff;
        return value < min ? min : (value > max ? max : value);
    }
    static toHex(value) {
        value &= 0xffff;
        if (value <= 0xf)
            return "0x000" + value.toString(16);
        else if (value <= 0xff)
            return "0x00" + value.toString(16);
        else if (value <= 0xfff)
            return "0x0" + value.toString(16);
        else
            return "0x" + value.toString(16);
    }
}
UInt16.min = 0x0000;
UInt16.max = 0xffff;
UInt16.bitWidth = 16;
UInt16.isSigned = false;
exports.UInt16 = UInt16;
//# sourceMappingURL=UInt16.js.map