"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const imul = Math.imul;
class UInt32 {
    static add(a, b) {
        return ((a >>> 0) + (b >>> 0)) >>> 0;
    }
    static sub(a, b) {
        return ((a >>> 0) - (b >>> 0)) >>> 0;
    }
    static mul(a, b) {
        return imul((a >>> 0), (b >>> 0)) >>> 0;
    }
    static div(a, b) {
        return ((a >>> 0) / (b >>> 0)) >>> 0;
    }
    static mod(a, b) {
        return ((a >>> 0) % (b >>> 0));
    }
    static fromNumber(v) {
        return v >>> 0;
    }
    static clamp(value, min, max) {
        value >>>= 0;
        min >>>= 0;
        max >>>= 0;
        return value < min ? min : (value > max ? max : value);
    }
    static toHex(value) {
        value >>>= 0;
        if (value <= 0xf)
            return "0x0000000" + value.toString(16);
        else if (value <= 0xff)
            return "0x000000" + value.toString(16);
        else if (value <= 0xfff)
            return "0x00000" + value.toString(16);
        else if (value <= 0xffff)
            return "0x0000" + value.toString(16);
        else if (value <= 0xfffff)
            return "0x000" + value.toString(16);
        else if (value <= 0xffffff)
            return "0x00" + value.toString(16);
        else if (value <= 0xfffffff)
            return "0x0" + value.toString(16);
        else
            return "0x" + value.toString(16);
    }
}
UInt32.min = 0x00000000;
UInt32.max = 0xffffffff;
UInt32.bitWidth = 32;
UInt32.isSigned = false;
exports.UInt32 = UInt32;
//# sourceMappingURL=UInt32.js.map