"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class UInt8 {
    static add(a, b) {
        return ((a & 0xff) + (b & 0xff)) & 0xff;
    }
    static sub(a, b) {
        return ((a & 0xff) - (b & 0xff)) & 0xff;
    }
    static mul(a, b) {
        return ((a & 0xff) * (b & 0xff)) & 0xff;
    }
    static div(a, b) {
        return ((a & 0xff) / (b & 0xff)) & 0xff;
    }
    static mod(a, b) {
        return ((a & 0xff) % (b & 0xff)) & 0xff;
    }
    static fromNumber(v) {
        return v & 0xff;
    }
    static clamp(value, min, max) {
        value &= 0xff;
        min &= 0xff;
        max &= 0xff;
        return value < min ? min : (value > max ? max : value);
    }
    static toHex(value) {
        value &= 0xff;
        if (value <= 0xf)
            return "0x0" + value.toString(16);
        else
            return "0x" + value.toString(16);
    }
}
UInt8.min = 0x00;
UInt8.max = 0xff;
UInt8.bitWidth = 8;
UInt8.isSigned = false;
exports.UInt8 = UInt8;
//# sourceMappingURL=UInt8.js.map